function [ a_rev ] = blkFlipud( a, k )
%BLKFLIPUD A block-version of flipud.
%
%   b = blkFlipud(a, k) is a block-version of flipud(). It returns the
%   block-vector/block-matrix a, with block-size k, fliped upside down,
%   block-wise, while keeping the internatl structure of the blocks.

if nargin ~= 2
    error('Need two input arguments')
end

[l,~] = size(a);

n = l/k;

indexSet = kron(k*(n:-1:1).', ones(k,1)) - kron(ones(n,1),(k-1:-1:0).');
a_rev = a(indexSet, :);

end

