%% Init
clear all
close all


%% Plot the data
x = [800, 1600, 3200, 6400];
y_th = [0.3795, 1.643, 5.900, 24.88];
y_th_std = [0.03223, 0.1319, 0.1536, 2.916];

y_bs =[0.09061, 0.6511, 4.645, 53.47];
y_bs_std = [0.008357, 0.03478, 0.07963, 11.82];


fig = figure;

set(0,'defaultAxesFontSize',14)
set(gcf,'PaperPositionMode','auto')
set(0, 'DefaultFigurePosition', [0 0 700 600]) 
set(0, 'defaultlinelinewidth', 2)
set(0, 'defaultaxesfontweight', 'bold')

errorbar(x, y_th, y_th_std, 'xg')
hold on
errorbar(x, y_bs, y_bs_std, 'xm')

lowerLimAxis = 400;
upperLimAxis = 10000;

xlim([lowerLimAxis upperLimAxis])

ylim([3e-2 5e2])


ax = get(fig,'CurrentAxes');
set(ax,'XScale','log','YScale','log')

lineParam_th = polyfit(log(x),log(y_th),1);
lineParam_bs = polyfit(log(x),log(y_bs),1);


lowExt_th = lineParam_th(1)*log(lowerLimAxis) + lineParam_th(2);
uppExt_th = lineParam_th(1)*log(upperLimAxis) + lineParam_th(2);
p1 = plot([lowerLimAxis, upperLimAxis], exp([lowExt_th, uppExt_th]), 'g--');

lowExt_bs = lineParam_bs(1)*log(lowerLimAxis) + lineParam_bs(2);
uppExt_bs = lineParam_bs(1)*log(upperLimAxis) + lineParam_bs(2);
p2 = plot([lowerLimAxis, upperLimAxis], exp([lowExt_bs, uppExt_bs]), 'm');


ylabel('Solution time [s]')
xlabel('Value of parameter n')

legend([p1, p2], 'Fast solver', 'Matlab''s solver', 'Location','NorthWest');


