clear all

%% Block-example
n = 3;
k = 2;

% Making the ones in t0 into i gives that A is not positive definite. The
% result is not correct when the inverse is computed. However, when the 1/2
% in t1 is change to 1/2i, T is not positive definite but A is. Then the
% result is correct.

t0 = [6, 1; 1, 7];
t1 = [5,1/2; 1/2, 4];
t2 = [4, 2; 2, 6];

a = [t0; t1; t2];
T = [t0, conj(t1), conj(t2); t1, t0, conj(t1); t2, t1, t0];

h0 = [11, 1/2; 1/2, 10];
h1 = [3, 1; 2, 2];
h2 = [7, 2; 2, 8];
h3 = [1, 1/2; 1/2, 2];
h4 = [8, 3/4; 3/4, 9];

b = [h0; h1; h2; h3; h4];
H = [h0, h1, h2; h1, h2, h3; h2, h3, h4];

A = T + H;


%% Scalar-example
% n = 4;
% k = 1;
% 
% a = [6;2+1/2*1i;0;2];
% b = [4;2;1;1;0;1;1];
% 
% % A = toeplitz(conj(a)) + hankel(b(1:n), b(n:end)); 
% % A = toeplitz(a) + hankel(b(1:n), b(n:end));
% A = blkToep(a) + blkHank(b);


%% The calculations
% Computing the fundamental solutions with the recursive function
x = fundSol(a,b);

% and with direct computations
g1 = [eye(k); zeros(k*(n-1),k)];
g2 = [zeros(k*(n-1),k); eye(k)];
g3 = - ( [a(k+1:n*k, :); zeros(k)] + [zeros(k); b(1:(n-1)*k, :)] );
g4 = - ( conj([zeros(k); blkFlipud(a(k+1:n*k, :),k)]) + [b(n*k + 1:(2*n-1)*k, :); zeros(k)]);

x1 = A\g1;
x2 = A\g2;
x3 = A\g3;
x4 = A\g4;

% Comparing the two results
norm(x - [x1, x2, x3, x4])

